# Contributing to CrazyCrates
Contributions to the project are always welcome, Pull Requests do have some guidelines before being approved.

## You should always create the fork as a personal repository not in an organization.
Any pull request made by a fork in an organization prevents modifications. Everyone has their own way of doing things and rather asking you to change that. A personal fork lets com change the things
that we have a tick about. 

If you do not use a personal fork, We have to manually merge your pull request which means it's marked as closed instead of merged.

## Requirements
 * `git`
 * Java 17 ( Adoptium is recommended )

Pull Requests must be labeled properly according to if it's a bug fix, a new feature or enhancements to the code base.
 * `git checkout -b fix/your_fix`
  * `git checkout -b feature/your_feature`
  * `git checkout -b quality/your_enhancement`
 * Commit your changes using `git commit -m 'your commit'`
 * Push to your branch using `git push`
 * Open a pull request to the `main` branch on our repository to add your change. 

You must explain what your pull request is changing and if needed, Supply a video of your change as Pull Requests are a way to get feedback.